clear all;
close all;

global left_feeder right_feeder nb_right_trial nb_wrong_trial reward_duration masker_atn;
global het_freq recdur std_atn_db irpts f double_blind pcorrh record_on side_seq actxh;
global result filename  messages feedbbuf feedback_min_dur masker_atn_def masker_atn_0 fs;
global playchan;
double_blind=0;
nb_right_reward=0;
nb_left_reward=0;
left_feeder=2;
right_feeder=1;
reward_duration=0.5;
het_freq=45000;         % heterodyning frequency for audio monitoring
record_on=0;

fs=192000;
het_loud=3;
rec_dur=4; % length of audio ringbuffer for trial documentation
nbufs=2;
feedback_threshold_output=-6;
feedback_min_dur=0.1;
masker_atn_def=-12; %masker attenuation [dB] in conditions with maskers present
masker_atn_0=-200; %masker attenuation [dB] in condition without maskers
masker_atn=masker_atn_0;

input_channels=0:5;
output_channels=0:7;
playchan=0:length(output_channels)-1;

rand('state',sum(100*clock));
messages={'';'';'';'';'';'';'';'';'';'';''};

load('100000_random_sides.mat'); % loads variable "side_seq" with a random sequence of 100,000 signal-sides
% make sure feeders are off
ppset_conny('lpt3',0);

%prepare soundmex
if 1 ~= soundmexpro('init','driver','ASIO Fireface','samplerate',fs,'input',input_channels,'output',output_channels,'numbufs',nbufs);
    error(['error calling ''init''' error_loc(dbstack)]);
end
% get asio properties
[ret,fs_ff800,bufsiz]=soundmexpro('getproperties');
fs=fs_ff800;
feedbbuf=round(feedback_min_dur*fs_ff800/bufsiz);
%set clipthreshold
if 1 ~= soundmexpro('clipthreshold','type','output','value',10^(feedback_threshold_output/20));
    error('error setting clipthreshold');
end

% set record length for audio ring buffer
if 1 ~= soundmexpro( 'recbufsize', 'value', rec_dur*fs);
    error(['error calling ''loadfile''' error_loc(dbstack)]);
end

% set IO Status
if 1~=soundmexpro('iostatus', 'input', 0, 'track', 0);
    error('error setting io status')
end
if 1~=soundmexpro('iostatus', 'input', 1, 'track', [1 6]);
    error('error setting io status')
end
if 1~=soundmexpro('iostatus', 'input', 2, 'track', 2);
    error('error setting io status')
end
if 1~=soundmexpro('iostatus', 'input', 3, 'track', 3);
    error('error setting io status')
end
if 1~=soundmexpro('iostatus', 'input', 4, 'track', [4 7]);
    error('error setting io status')
end
if 1~=soundmexpro('iostatus', 'input', 5, 'track', 5);
    error('error setting io status')
end

% load convolver for each stereo pair
for stp=1:3,
    convch=playchan(stp*2-1:stp*2);
    % now load the plugin
    if 1 ~= soundmexpro('vstload', ...
            'filename', 'D:\Programme\SoundMexPro\plugins\HtVSTConv.dll', ...
            'type','track','input', convch, ...
            'output', convch ...
            );
        error('error calling vstload');
    end
end

% % generate IR
% f=[0 25e3 30e3 90e3 94e3 fs/2];
% mdb=[-80 -80 -10 -7 0 0];
% f=f/(fs/2);
% m=10.^(mdb/20);
% irs(:,1)=fir2(40,f,m);
% irs(:,2)=irs(:,1);
% wavwrite(irs,fs,32,'rv1_ir');
% 
% % load the IR for each stereo pair
% for stp=1:3,
%     convch=playchan(stp*2-1:stp*2);
%     % load an impulse response
%     if 1 ~= soundmexpro('vstprogramname','type','track', ...
%             'input',(convch(1)),'programname', 'rv1_ir.wav' ...
%             )
%         error(['error calling ''vstprogramname''' error_loc(dbstack)]);
%     end
% end

% load heterodyning plugin for last stereo pair
if 1 ~= soundmexpro('vstload', ...
        'filename', 'D:\Programme\SoundMexPro\plugins\HtVSTHeterodyning.dll', ...
        'position', 1, ...
        'type','track', ...
        'input', [6 7], ...
        'output', [6 7] ...
        );
    error('error calling vstload');
end

% set heterodyning frequencies of first two channels in fractions of the sample
% frequency
if 1 ~= soundmexpro('vstparam',  ...                                % command name
        'input', [6 7], ...
        'position', 1, ...
        'type','track', ...
        'parameter', {'enabled', 'frequency_0', 'frequency_1'}, ... % parameter names
        'value', [1 het_freq/fs het_freq/fs] ...                          % parameter values
        );
    error(['error calling ''vstparam''' error_loc(dbstack)]);
end

global fh start left_handle right_handle abort_handle start_handle...
    end_session side nb_trial nb_aborted_trial left_feeder_handle right_feeder_handle rovh...
    nb_manual_reward name_handle message_handle atnh masker_handle nth recordh maskeratns_handle maskerdelh;
ppset_conny('lpt3',0);
fh=rv1gui;
set(fh,'Position',[ 20.2000   41.1538  133.8000   35.3846]);
ppset_conny('lpt3',0);
left_handle=findobj(fh,'tag','left');
right_handle=findobj(fh,'tag','right');
abort_handle=findobj(fh,'tag','abort');
start_handle=findobj(fh,'tag','start');
left_feeder_handle=findobj(fh,'tag','reward_left');
right_feeder_handle=findobj(fh,'tag','reward_right');
name_handle=findobj(fh,'tag','names');
masker_handle=findobj(fh,'tag','maskers');
message_handle=findobj(fh,'tag','message');
atnh=findobj(fh,'tag','atn');
nth=findobj(fh,'tag','nt');
pcorrh=findobj(fh,'tag','pcorr');
recordh=findobj(fh,'tag','record_on');
maskeratns_handle=findobj(fh,'tag','masker_atns');
maskerdelh=findobj(fh,'tag','maskerdel');
rovh=findobj(fh,'tag','rov_lvl');

set(start_handle,'string','Start','backgroundcolor',[0 0.498 0],'enable','on');
set(abort_handle,'backgroundcolor',[0.847 0.161 0],'enable','off');
set([left_handle right_handle],'backgroundcolor',[0.749 0.749 0],'enable','on');


