function resp1fkt(action)
global left_feeder right_feeder reward_duration_li reward_duration_re;
global result filename   messages sequence trn sigside resside;
global start left_handle right_handle abort_handle start_handle recordh...
    right_feeder_handle left_feeder_handle side_seq side_pos...
    name_handle masker_handle message_handle atnh pcorrh nth t batname sm_record sigdelh;
global fs recchan playchan lcv tw fh double_blind atn masker_handle pcorrh masker atn record_on masker_atn_0;
global  RP actxh trig_lh trig_rh started feedbbuf feedback_min_dur trial_on masker_atn_def masker_atn;
global maskeratns_handle rovh call left_feeder_auto_handle right_feeder_auto_handle sigallchannels;

switch action,
    case 'names',
        names=get(name_handle,'string');
        nv=get(name_handle,'value');
        batname=names{nv};
        filename=['data\resp1_' batname '.mat'];
        fid=fopen(filename);
        if fid>0,
            fclose(fid);
            load(filename);
        else
            result=[];
        end
        % Position in the Gellermann vector for the side of the first
        % playback.
        side_pos=ceil(rand*length(side_seq));
        ppset_conny('lpt3',4);

    case 'maskers',
        maskers=get(masker_handle,'string');
        mv=get(masker_handle,'value');
        masker=str2num(maskers{mv});
        if strcmp(maskers{mv}, '0')
            masker_atn=masker_atn_0;
        else
            masker_atn=masker_atn_def;
        end

        % read in signal delay
        sigdels=get(sigdelh,'string');
        sigdelv=get(sigdelh,'value');
        sigdel=str2num(sigdels{sigdelv});

        % read in masker attenuation
        maskeratns_tab=get(maskeratns_handle,'string');
        mav_tab=get(maskeratns_handle,'value');
        maskeratn_tab=str2num(maskeratns_tab{mav_tab});
        if strcmp(maskers{mv}, '0')
            maskeratn_tab=-200;
        end

        rov_lvl=get(rovh,'value');

        % update trial information
        if length(result)>0
            attenuations=0:-3:-81;
            for attn=1:length(attenuations),
                xatt=attenuations(attn);
                nts(attn)=length(find(result(4,:)==attenuations(attn) & result(3,:)==masker & result(5,:)==maskeratn_tab & result(10,:)==sigdel & result(11,:)==rov_lvl));
                pcorrs(attn)=round((length(find(result(4,:)==attenuations(attn) & result(10,:)==sigdel & result(3,:)==masker & result(5,:)==maskeratn_tab & result(11,:)==rov_lvl & result(8,:)==result(9,:)))/length(find(result(4,:)==attenuations(attn) & result(3,:)==masker & result(5,:)==maskeratn_tab & result(10,:)==sigdel & result(11,:)==rov_lvl)))*100);
            end
            tnstring=num2str(nts');
            set(nth,'string',tnstring);
            pcorrstring=num2str(pcorrs');
            set(pcorrh,'string',pcorrstring);
        end

    case 'masker_atns',
        maskeratns=get(maskeratns_handle,'string');
        mav=get(maskeratns_handle,'value');
        if masker~=0
            masker_atn=str2num(maskeratns{mav});
        end

    case 'start',
        set(start_handle,'string','Playback ON','backgroundcolor',[0.847 0.161 0],'enable','off');
        set(abort_handle,'backgroundcolor',[0 0.498 0],'enable','on','string','abort');
        set(left_handle,'string','gone left','backgroundcolor',[0 0.498 0],'enable','on');
        set(right_handle,'string','gone right','backgroundcolor',[0 0.498 0],'enable','on');
        record_on=get(recordh,'value');
        % select rewarded side
        sigside=side_seq(side_pos);
        side_pos=side_pos+1;
        if side_pos>length(side_seq),
            side_pos=1;
        end;

        prepare_trial;
        
% %         sigallchannels(1000:3000,:)
% %         figure(10)
% %         plot(sigallchannels)
% % size(sigallchannels)

        if 1 ~= soundmexpro('loadmem', ...      % command name
                'data', sigallchannels, ...              % data vector
                'track', 0:5, ...             % tracks, here 0 and 1 (one track on each channel)
                'loopcount', 0 ...              % loopcount
                );
            error(['error calling ''loadmem''' error_loc(dbstack)]);
        end

        % start soundmexpro!
        if 1 ~= soundmexpro('start','length',0);
            error('error calling start');
        end
        tic;
        newmessage('New trial started!');

        % wait until either abort key is pressed or the bat makes decision!
        while strcmp(get(abort_handle,'string'),'abort') && strcmp(get(left_handle,'string'),'gone left') && strcmp(get(right_handle,'string'),'gone right'),
            [success, clipout,clipin]=soundmexpro('clipcount');
            if success ~= 1;
                error('error in clipcount');
            end
            if max(clipout)>=feedbbuf,
                % stop the filtering
                if 1 ~= soundmexpro('stop');
                    error('error calling stop');
                end
                set(abort_handle,'string','Trial aborted');
                newmessage('Feedback occurred, filtering stopped!')
            end
            soundmexpro('resetclipcount');
            pause(feedback_min_dur*2);
        end

        if 1~= soundmexpro('resetclipcount')
            error('error reseting clipcount');
        end

    case 'signal left'
        set(start_handle,'string','Playback ON','backgroundcolor',[0.847 0.161 0],'enable','off');
        set(abort_handle,'backgroundcolor',[0 0.498 0],'enable','on');
        set([left_handle right_handle],'backgroundcolor',[0.847 0.161 0],'enable','off');
        record_on=get(recordh,'value');
        sigside=1;
        prepare_trial;
        if 1 ~= soundmexpro('loadmem', ...      % command name
                'data', sigallchannels, ...              % data vector
                'track', 0:5, ...             % tracks, here 0 and 1 (one track on each channel)
                'loopcount', 0 ...              % loopcount
                );
            error(['error calling ''loadmem''' error_loc(dbstack)]);
        end

        % start soundmexpro!
        if 1 ~= soundmexpro('start','length',0);
            error('error calling start');
        end
        tic;
        newmessage('New trial started!');
        trial_on=1;
        % wait until abort key is pressed!
        while trial_on==1,
            [success, clipout,clipin]=soundmexpro('clipcount');
            if success ~= 1;
                error('error in clipcount');
            end
            if max(clipout)>=feedbbuf,
                % stop the filtering
                if 1 ~= soundmexpro('stop');
                    error('error calling stop');
                end
                set(abort_handle,'string','Trial aborted');
                newmessage('Feedback occurred, filtering stopped!')
            end
            soundmexpro('resetclipcount');
            pause(feedback_min_dur*2);
        end

        if 1~= soundmexpro('resetclipcount')
            error('error reseting clipcount');
        end

    case 'signal right'
        set(start_handle,'string','Playback ON','backgroundcolor',[0.847 0.161 0],'enable','off');
        set(abort_handle,'backgroundcolor',[0 0.498 0],'enable','on');
        set([left_handle right_handle],'backgroundcolor',[0.847 0.161 0],'enable','off');
        record_on=get(recordh,'value');
        sigside=2;
        prepare_trial;
        if 1 ~= soundmexpro('loadmem', ...      % command name
                'data', sigallchannels, ...              % data vector
                'track', 0:5, ...             % tracks, here 0 and 1 (one track on each channel)
                'loopcount', 0 ...              % loopcount
                );
            error(['error calling ''loadmem''' error_loc(dbstack)]);
        end

        % start soundmexpro!
        if 1 ~= soundmexpro('start','length',0);
            error('error calling start');
        end
        tic;
        newmessage('New trial started!');

        trial_on=1;
        % wait until abort key is pressed!
        while trial_on==1,
            [success, clipout,clipin]=soundmexpro('clipcount');
            if success ~= 1;
                error('error in clipcount');
            end
            if max(clipout)>=feedbbuf,
                % stop the filtering
                if 1 ~= soundmexpro('stop');
                    error('error calling stop');
                end
                set(abort_handle,'string','Trial aborted');
                newmessage('Feedback occurred, filtering stopped!')
            end
            soundmexpro('resetclipcount');
            pause(feedback_min_dur*2);
        end

        if 1~= soundmexpro('resetclipcount')
            error('error reseting clipcount');
        end

    case 'gone left',
        stop_trial;
        resside=1;
        analyse_response;


    case 'gone right',
        stop_trial;
        resside=2;
        analyse_response;

    case 'abort',
        stop_trial;
        ppset_conny('lpt3',4);
        % reset buttons
        set(start_handle,'string','Start','backgroundcolor',[0 0.498 0],'enable','on');
        set(left_handle,'string','signal left','backgroundcolor',[0.749 0.749 0],'enable','on');
        set(right_handle,'string','signal right','backgroundcolor',[0.749 0.749 0],'enable','on');

    case 'quit';
        soundmexpro('exit');
        ppset_conny('lpt3',0);
        close(fh);

    case 'reward_left', % switch on left feeder
        ppset_conny('lpt3',left_feeder);
        set(left_feeder_handle,'backgroundcolor',[0.847 0.161 0],'string','stop_reward_left');

    case 'reward_right', % switch on right feeder
        ppset_conny('lpt3',right_feeder);
        set(right_feeder_handle,'backgroundcolor',[0.847 0.161 0],'string','stop_reward_right');

    case 'reward_left_auto', % switch on left feeder
        ppset_conny('lpt3',left_feeder);
        newmessage('Bat is rewarded at the left feeder');
        pause(reward_duration_li);
        ppset_conny('lpt3',0);
        ppset_conny('lpt3',4);

    case 'reward_right_auto', % switch on right feeder
        ppset_conny('lpt3',right_feeder);
        newmessage('Bat is rewarded at the right feeder');
        pause(reward_duration_re);
        ppset_conny('lpt3',0);
        ppset_conny('lpt3',4);

    case 'stop_reward_left', % switch off left feeder
        ppset_conny('lpt3',0);
        %         ppset_conny('lpt3',4);
        set(left_feeder_handle,'backgroundcolor',[0 0.498 0],'string','reward_left');

    case 'stop_reward_right', % switch off right feeder
        ppset_conny('lpt3',0);
        %         ppset_conny('lpt3',4);
        set(right_feeder_handle,'backgroundcolor',[0 0.498 0],'string','reward_right');

    otherwise,error('unkown argument for res1fkt');

end

function prepare_trial
global start left_handle right_handle abort_handle start_handle end_session...
    side    right_feeder_handle left_feeder_handle rovh...
    name_handle masker_handle message_handle pcorrh nth atnh t atn_db playchan rov_lvl;
global sequence trn sigside lcv tw side_seq side_pos rov_db1 rov_db2 sigdelh sigdel;
global fs recchan playchan irpts f double_blind atn masker_handle masker atn masker_atn trig_lh trig_rh;
global masker_atn_def masker_atn_0 call sigallchannels frep
% read in atn
atns=get(atnh,'string');
atnv=get(atnh,'value');
atn=str2num(atns{atnv});

% read in masker
maskers=get(masker_handle,'string');
mv=get(masker_handle,'value');
masker=str2num(maskers{mv});
% if strcmp(maskers{mv}, '0')
%     masker_atn=masker_atn_0;
% else
%     masker_atn=masker_atn_def;
% end
% if strcmp(num2str(masker), '0')
% rov_db1=0;
% rov_db2=0;
% else
%     rov_db1=ceil(rand*13)-7; %roving level +/- 6 dB left
%     rov_db2=ceil(rand*13)-7; %roving level +/- 6 dB right
%     newmessage(['rov1= ' num2str(rov_db1) ' dB; rov2= ' num2str(rov_db2) ' dB']);
% end
rov_lvl=get(rovh,'value');
if rov_lvl
    rov_db1=ceil(rand*13)-7; %roving level +/- 6 dB left
    rov_db2=ceil(rand*13)-7; %roving level +/- 6 dB right
    newmessage(['rov1= ' num2str(rov_db1) ' dB; rov2= ' num2str(rov_db2) ' dB']);
else
    rov_db1=0;
    rov_db2=0;
end


% read in signal delay (in ms)
sigdels=get(sigdelh,'string');
sigdelv=get(sigdelh,'value');
sigdel=str2num(sigdels{sigdelv})
del_samples=abs(sigdel)/1000*fs;
if sigdel<0;
    %masker channels
    sigallchannels(:,1)=[zeros(round(del_samples),1);zeros(2000,1);call;zeros(round(fs/frep-length(call)-del_samples-2000),1)];
    sigallchannels(:,3)=[zeros(round(del_samples),1);zeros(2000,1);call;zeros(round(fs/frep-length(call)-del_samples-2000),1)];
    sigallchannels(:,4)=[zeros(round(del_samples),1);zeros(2000,1);call;zeros(round(fs/frep-length(call)-del_samples-2000),1)];
    sigallchannels(:,6)=[zeros(round(del_samples),1);zeros(2000,1);call;zeros(round(fs/frep-length(call)-del_samples-2000),1)];
    %signal channels
    sigallchannels(:,2)=[zeros(2000,1);call;zeros(round(fs/frep-length(call)-2000),1)];
    sigallchannels(:,5)=[zeros(2000,1);call;zeros(round(fs/frep-length(call)-2000),1)];
elseif sigdel>=0
     %masker channels
    sigallchannels(:,1)=[zeros(2000,1);call;zeros(round(fs/frep-length(call)-2000),1)];
    sigallchannels(:,3)=[zeros(2000,1);call;zeros(round(fs/frep-length(call)-2000),1)];
    sigallchannels(:,4)=[zeros(2000,1);call;zeros(round(fs/frep-length(call)-2000),1)];
    sigallchannels(:,6)=[zeros(2000,1);call;zeros(round(fs/frep-length(call)-2000),1)];
    %signal channels
    sigallchannels(:,2)=[zeros(round(del_samples),1);zeros(2000,1);call;zeros(round(fs/frep-length(call)-del_samples-2000),1)];
    sigallchannels(:,5)=[zeros(round(del_samples),1);zeros(2000,1);call;zeros(round(fs/frep-length(call)-del_samples-2000),1)];
else
    newmessage('ERROR in masker delay');
end

% define channel vector
masker_atn
cv=zeros(1,6);
rov_db1
rov_db2
cv([1 3])=10^((masker_atn+rov_db1)/20);
cv([4 6])=10^((masker_atn+rov_db2)/20);
if sigside==1,
    % set attenuation for rewarded side
    cv(2)=10^((atn+rov_db1)/20);
    % set attenuation for unrewarded side
    cv(5)=0;
elseif sigside==2,
    % set attenuation for rewarded side
    cv(5)=10^((atn+rov_db2)/20);
    % set attenuation for unrewarded side
    cv(2)=0;
else
    newmessage('ERROR in sigside');
end
% cv([7:8])=1;

lcv=cv;

% now set transmission level for all channels
[success, volume] = soundmexpro('trackvolume', ...
    'track', 0:5, ...
    'value', lcv ...
    );
if success ~= 1
    error(['error calling ''trackvolume''' error_loc(dbstack)]);
end

% % switch on debugsave (i.e. writing played data to file)
% if 1 ~= soundmexpro('debugsave', 'value', [1]);
%     error(['error calling ''debugsave''' error_loc(dbstack)]);
% end

if double_blind==0,
    if sigside==1,
        newmessage('Rewarded side LEFT');
    else
        newmessage('Rewarded side RIGHT');
    end
end
ppset_conny('lpt3',0)


function stop_trial
global left_handle right_handle abort_handle record_on RP started trial_on;
set(left_handle,'string','gone left','enable','off');
set(right_handle,'string','gone right','enable','off');
% first stop soundmexpro
if 1 ~= soundmexpro('stop');
    error('error calling stop');
end

% get xrun information
[success, xruns pxrun]=soundmexpro('xrun');
newmessage(['Trial stopped with ' num2str(xruns) ' XRUNs and ' num2str(pxrun) ' processing XRUNs!']);

trial_on=0;

set(abort_handle,'backgroundcolor',[0.847 0.161 0],'enable','off');
% set(left_handle,'string','signal left','backgroundcolor',[0.749 0.749 0],'enable','on');
% set(right_handle,'string','signal right','backgroundcolor',[0.749 0.749 0],'enable','on');


function analyse_response
global result sigside resside lcv tw left_feeder right_feeder nth reward_duration_li reward_duration_re filename fs masker_atn;
global left_handle right_handle abort_handle start_handle nth masker_handle batname pcorrh masker atn;
global record_on RP rov_db1 rov_db2 sigdel rov_lvl;
latency=toc;
% first provide feedback
if resside==sigside,
    newmessage('Correct response');
    if sigside==1,
        ppset_conny('lpt3',left_feeder);
        newmessage('Bat is rewarded at the left feeder');
        pause(reward_duration_li);
        ppset_conny('lpt3',0);
        ppset_conny('lpt3',4);
    else
        ppset_conny('lpt3',right_feeder);
        newmessage('Bat is rewarded at the right feeder');
        pause(reward_duration_re);
        ppset_conny('lpt3',0);
        ppset_conny('lpt3',4);
    end
else
    ppset_conny('lpt3',4);
    newmessage('Wrong response');
end
% save performance data
time_stamp=now;
maskers=get(masker_handle,'string');
mv=get(masker_handle,'value');
masker=str2num(maskers{mv});

trinput=[time_stamp;latency;masker;atn;masker_atn;rov_db1;rov_db2;sigside;resside;sigdel;rov_lvl]; %rov_lvl erst ab 30.7.2010 gltig vorher immer 0
result=[result trinput];
save(filename,'result');
newmessage('Performance saved');
% update trial information
attenuations=0:-3:-81;
for attn=1:length(attenuations),
    xatt=attenuations(attn);
    nts(attn)=length(find(result(4,:)==attenuations(attn) & result(3,:)==masker & result(5,:)==masker_atn & result(10,:)==sigdel & result(11,:)==rov_lvl));
    %nts_corr(attn)=length(find(result(3,:)==atn & result(2,:)==masker & result(4,:)==result(5,:)));
    pcorrs(attn)=round((length(find(result(4,:)==attenuations(attn) & result(3,:)==masker & result(5,:)==masker_atn & result(10,:)==sigdel & result(11,:)==rov_lvl & result(8,:)==result(9,:)))/length(find(result(4,:)==attenuations(attn) & result(3,:)==masker & result(5,:)==masker_atn & result(10,:)==sigdel & result(11,:)==rov_lvl)))*100);
end
tnstring=num2str(nts');
set(nth,'string',tnstring);
pcorrstring=num2str(pcorrs');
set(pcorrh,'string',pcorrstring);

ntrials=length(find(floor(result(1,:))==floor(now)));
tcorr=length(find(floor(result(1,:))==floor(now)&result(8,:)==result(9,:)));
pc=tcorr/ntrials*100;
newmessage(['ntrials=' num2str(ntrials) ';  pcorr=' num2str(pc)]);

if record_on,
    % save sound data
    wavname=['sounds\resp1_' batname '_' strrep(num2str(masker),'.','-') '_' strrep(num2str(time_stamp,'%5.5f'),'.','_')];
    %get contents of record buffer
    [success, recbuf, pos] = soundmexpro('recgetdata');
    if success ~= 1;
        clear all
        error(['error calling ''recgetdata''' error_loc(dbstack)]);
    end
    save(wavname,'recbuf');
    %         wavwrite(recbuf,fs,wavname);
    newmessage('Sounds saved');
end
% reset buttons
set(start_handle,'string','Start','backgroundcolor',[0 0.498 0],'enable','on');
set(left_handle,'string','signal left','backgroundcolor',[0.749 0.749 0],'enable','on');
set(right_handle,'string','signal right','backgroundcolor',[0.749 0.749 0],'enable','on');


function newmessage(message)
global messages message_handle;
messages{1}=messages{2};
messages{2}=messages{3};
messages{3}=messages{4};
messages{4}=messages{5};
messages{5}=messages{6};
messages{6}=messages{7};
messages{7}=messages{8};
messages{8}=messages{9};
messages{9}=messages{10};
messages{10}=messages{11};
messages{11}=[datestr(rem(now,1),'HH:MM:SS') ' ' message];
set(message_handle,'string',messages);
drawnow;
